<?php

namespace Drupal\Tests\codemirror_editor\FunctionalJavascript;

/**
 * Tests the CodeMirror editor settings form.
 *
 * @group codemirror_editor
 */
class SettingsFormTest extends TestBase {

  /**
   * Test callback.
   */
  public function testSettingsForm() {
    $assert_session = $this->assertSession();
    $page = $this->getSession()->getPage();

    // Make sure the form is not accessible by unprivileged users.
    $default_user = $this->drupalCreateUser(['access content']);
    $this->drupalLogin($default_user);
    $this->drupalGet('admin/config/content/codemirror');
    $assert_session->pageTextContains('Access denied');

    $admin_user = $this->drupalCreateUser(['access content', 'administer codemirror editor']);
    $this->drupalLogin($admin_user);
    $this->drupalGet('admin/config/content/codemirror');
    $assert_session->pageTextContains('CodeMirror configuration');

    $page->selectFieldOption('Theme', 'cobalt');
    $page->pressButton('Save configuration');
    $assert_session->pageTextContains('The configuration options have been saved.');

    $this->drupalGet('codemirror-editor-test');
    $this->activeEditor = 1;
    $this->assertEditorOption('theme', 'cobalt');
  }

}
